/* -*- mode: c; c-basic-offset: 4; -*- */
/* vi:set cindent ts=8 sts=4 sw=4: */
#ifndef CURS_MAIN_H
#define CURS_MAIN_H

#include <stdio.h>		/* size_t */

#define NOP 0 /* no operation */
/* the line number of the status line */
#define STATUS_LINE 0
/* the line number of the command reference */
#define CMD_REF_LINE (LINES - 2)
/* the line number of the message line */
#define MSG_LINE (LINES - 1)

#define REDRAW_INDEX         (1<<0)
#define REDRAW_MOTION        (1<<1)
#define REDRAW_CURRENT       (1<<2)
#define REDRAW_STATUS        (1<<3)
#define REDRAW_CMD_REF       (1<<4)
#define REDRAW_FULL          (1<<5)

#define MENU_MAIN    (1<<0)
#define MENU_OPTIONS (1<<1)
#define MENU_HELP    (1<<2)
#define MENU_BROWSER (1<<3)
#define ALL_MENUS MENU_MAIN | MENU_OPTIONS | MENU_HELP | MENU_BROWSER
#define LINE_EDITOR  (1<<4) /* special "menu" */

struct menu {
    int menu;		       /* what menu it is */
    int redraw;		       /* parts of the menu to be redrawed */
    int current;	       /* current entry, indexing starts at 0 */
    int oldcurrent;            /* the previous value of the `current' member,
				  redraw_screen() takes care of updating it */
    int entries;       	       /* number of entries in the menu */
    int offset;		       /* screen row to start the index */
    int pagelen;	       /* number of entries per screen */
    int top;		       /* entry that is the top of the current page */
    /* generates an index line for the requested element */
    /* line, sizeof line, index number */
    void (*make_entry) (char *, size_t, int);
    void (*search) (struct menu *, int op); /* the menu's search function */
    int prev_main_search_op;   /* the previous main search operation
				  (CMD_REGEXP_SEARCH_BACKWARD or
				  CMD_REGEXP_SEARCH_FORWARD) */
    char prev_search_str[32];  /* string searched for in the previous search */
                               /* we don't bother allocating it dynamically */
};

void init_first_menu(void);
void menu_loop(void);

#endif				/* CURS_MAIN_H */
